<?php
/*
Plugin Name: p01-contact
Description: Replace (% contact:me@exemple.com %) by a contact form
Version: 0.2
Author: Nicolas Liautaud
Author URI: http://nliautaud.fr
*/

$enable = 1;  # enable or disable mail sending
$lang = 'en'; # plugin language (en,fr)

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 	# ID of plugin, should be filename minus php
	'p01-contact', 	# Title of plugin
	'0.2', 		# Version of plugin
	'Nicolas Liautaud',	# Author of plugin
	'http://nliautaud.fr', 	# Author URL
	'Replace (% contact:me@exemple.com %) tag by a contact form', 	# Plugin Description
	'plugins', 	# Page type of plugin
	''  	# Function that displays content
);

# activate filter
add_filter('content','content_p01contact');

/*
  Filter Content for adsense markers (%ad_id%)
    the add of that id will be inserted in the markers section of the conent
*/
function content_p01contact($contents) {
    $data = isset($_POST['contact']) ? prepare_data($_POST['contact']) : '';
    
    // send mail, display message
    $msg = '';
    if(!empty($data)) {
        $msg = send_message($data);
    }

    // parse page content
    $tmpContent = $contents;
    preg_match_all('`\(% *contact *: *(.*) *%\)`',$tmpContent,$tmpArr);
    
    $AlltoReplace = $tmpArr[count($tmpArr)-1];
    $totalToReplace = count($AlltoReplace);
    for ($i=0;$i<$totalToReplace;$i++) {
        $tmpContent = preg_replace('`\(% *contact *: *.* *%\)`',get_form($tmpArr[1][$i], $data, $msg),$tmpContent);
    }
    return $tmpContent;
}

function get_form($tget, $m, $msg) {
    $form  = '<form action="" class="contactform" method="post"><table>';
    if(is_array($msg)) $form .= '<tr><td colspan="2">' . message($msg) . '</td></tr>';
    $form .= '    <tr><td><label for="name">'.lang('name').' <strong>*</strong> :</label></td><td><input id="name" name="contact[name]" type="text" value="' . (isset($m['name'])?$m['name']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="email">'.lang('email').' <strong>*</strong> :</label></td><td><input id="email" name="contact[email]" type="text" value="' . (isset($m['email'])?$m['email']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="address">'.lang('address').' :</label></td><td><textarea id="address" name="contact[address]" type="text" rows="2">' . (isset($m['address'])?$m['address']:'') . '</textarea></td></tr>';
    $form .= '    <tr><td><label for="phone">'.lang('phone').' :</label></td><td><input id="phone" name="contact[phone]" type="text" value="' . (isset($m['phone'])?$m['phone']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="subject">'.lang('subject').' :</label></td><td><input id="subject" name="contact[subject]" type="text" value="' . (isset($m['subject'])?$m['subject']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="message">'.lang('message').' <strong>*</strong> :</label></td><td><textarea id="message" name="contact[message]" rows="10">' . (isset($m['message'])?$m['message']:'') . '</textarea></td></tr>';
    $form .= '    <tr><td><input name="contact[tget]" type="hidden" value="' . $tget . '" /></td><td><input class="submit" id="contact-submit" name="contact-submit" type="submit" value="'.lang('send').'" /></td></tr>';
    $form .= '</table></form>';
    return $form;
}

function send_message($m) {
    if(!empty($m['name']) && check_email($m['email']) && !empty($m['message'])) {
    
        $message .= '<h1>' . lang('sentfrom') . ' ' . get_page_url(1) . '</h1>';
        $message .= '<ul><li>'.lang('date').' : ' . date('r') . '</li>';
        $message .= '<li>'.lang('from').' : ' . $m['name'] . '</li>';
        $message .= '<li>'.lang('email').' : ' . $m['email'] . '</li>';
        if(!empty($m['phone']))   $message .= '<li>'.lang('phone').' : ' . $m['phone'] . '</li>';
        if(!empty($m['address'])) $message .= '<li>'.lang('address').' : ' . $m['address'] . '</li>';
        $message .= '</ul><p>' . nl2br($m['message']) . '</p>';

        preg_match("`([^/]*)/(index\.php\?id=)?[^/=]+$`",get_page_url(1),$out);
        $sitename = $out[1];
        $subject = $m['subject'] . ' (' . lang('sentfrom') . ' ' . $sitename . ')';
        
        $headers  = "From: ".$m['email']."\r\n";
        $headers .= "Reply-To: ".$m['email']."\r\n";
        $headers .= "Return-Path: ".$m['email']."\r\n";
        $headers .= "MIME-Version: 1.0\r\n";
        $headers .= "Content-type: text/html; charset=UTF-8\r\n";

        if($enable){
            mail($m['tget'],'=?UTF-8?B?'.base64_encode($subject).'?=',"$message",$headers);
            return array(lang('sent'),'green','#dfd');
        } 
        return array(lang('notactive'),'red','#ffd');
    }
    return array(lang('senderror'),'red','#fdd');
}

function check_email($e) {
    $pattern = "^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$";
    if(eregi($pattern,$e)) {
        return 1;
    }
    return 0;
}

function prepare_data($array){
    foreach($array as $key => $val){
        $array[$key] = htmlentities(utf8_decode($val));
    }
    return $array;
}

function lang($key){
    global $lang;
    $words = array(
        'name'     => array('en' => 'Name',            'fr' => 'Nom'),
        'email'    => array('en' => 'Email',           'fr' => 'Adresse email'),
        'address'  => array('en' => 'Postal address',  'fr' => 'Adresse postale'),
        'phone'    => array('en' => 'Phone number',    'fr' => 'Numéro de téléphone'),
        'subject'  => array('en' => 'Subject',         'fr' => 'Objet'),
        'message'  => array('en' => 'Message',         'fr' => 'Message'),
        'send'     => array('en' => 'Send',            'fr' => 'Envoyer'),
        'sentfrom' => array('en' => 'Sent from',       'fr' => 'Envoyé depuis'),
        'date'     => array('en' => 'Date',            'fr' => 'Date'),
        'from'     => array('en' => 'From',            'fr' => 'De'),
        'sent'     => array('en' => 'Email sent.',     'fr' => 'Email envoyé.'),
        'notactive'=> array('en' => 'The p01-contact plugin is disable, message not sent.',
                            'fr' => 'Le plugin p01-contact est désactivé, le message n\'a pas été envoyé.'),
        'senderror'=> array('en' => 'Please enter at least your name, a valid email address and your message.',
                            'fr' => 'Veuillez indiquer au minimum votre nom, une adresse email valide et votre message.')
    );
    return $words[$key][$lang];
}

function message($msg){
    return "<div style='font-size:0.8em;color:" . $msg[1] . ";padding:0.5em;background-color:" . $msg[2] . ";'>" . $msg[0] . "</div>";
}
